Index: /trunk/NEMOGCM/CONFIG/GYRE_PISCES/EXP00/file_def_nemo.xml
===================================================================
--- /trunk/NEMOGCM/CONFIG/GYRE_PISCES/EXP00/file_def_nemo.xml	(revision 7827)
+++ /trunk/NEMOGCM/CONFIG/GYRE_PISCES/EXP00/file_def_nemo.xml	(revision 7828)
@@ -29,5 +29,5 @@
 	  <field field_ref="empmr"        name="sowaflup"  />
 	  <field field_ref="qsr"          name="soshfldo"  />
-      <field field_ref="saltflx"      name="sosfldow"  />
+          <field field_ref="saltflx"      name="sosfldow"  />
 	  <field field_ref="qt"           name="sohefldo"  />
 	  <field field_ref="mldr10_1"     name="somxl010"  />
Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM3_PISCES/EXP00/file_def_nemo.xml
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM3_PISCES/EXP00/file_def_nemo.xml	(revision 7827)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM3_PISCES/EXP00/file_def_nemo.xml	(revision 7828)
@@ -71,5 +71,6 @@
 	  <field field_ref="uoce"         name="uo"       operation="instant" freq_op="5d" > @uoce_e3u / @e3u </field>
 	  <field field_ref="utau"         name="tauuo"    />
-          <!-- available with key_diaar5 -->
+          <field field_ref="uocetr_eff"   name="uocetr_eff"  />
+          <!-- available with diaar5 -->
 	  <field field_ref="u_masstr"     name="vozomatr" />
 	  <field field_ref="u_heattr"     name="sozohetr" />
@@ -82,8 +83,9 @@
 	  <field field_ref="voce"         name="vo"       operation="instant" freq_op="5d" > @voce_e3v / @e3v </field>
 	  <field field_ref="vtau"         name="tauvo"    />
-          <!-- available with key_diaar5 -->
+          <field field_ref="vocetr_eff"   name="vocetr_eff"  />
+          <!-- available with diaar5 -->
 	  <field field_ref="v_masstr"     name="vomematr" />
 	  <field field_ref="v_heattr"     name="somehetr" />
-      <field field_ref="v_salttr"     name="somesatr" />
+          <field field_ref="v_salttr"     name="somesatr" />
 	</file>
 	
@@ -93,4 +95,11 @@
 	  <field field_ref="avt"          name="difvho"   />
 	  <field field_ref="w_masstr"     name="vovematr" />
+          <!-- variables available with key_zdftmx_new -->
+          <field field_ref="av_wave"      name="av_wave"    />
+          <field field_ref="bn2"          name="bn2"        />
+          <field field_ref="bflx_tmx"     name="bflx_tmx"   />
+          <field field_ref="pcmap_tmx"    name="pcmap_tmx"  />
+          <field field_ref="emix_tmx"     name="emix_tmx"   />
+          <field field_ref="av_ratio"     name="av_ratio"   />
 	</file>
 
Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM3_PISCES/EXP00/namelist_cfg
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM3_PISCES/EXP00/namelist_cfg	(revision 7827)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM3_PISCES/EXP00/namelist_cfg	(revision 7828)
@@ -134,4 +134,5 @@
 &namtra_adv_mle !  mixed layer eddy parametrisation (Fox-Kemper param)
 !-----------------------------------------------------------------------
+   ln_mle      = .true.   ! (T) use the Mixed Layer Eddy (MLE) parameterisation
 /
 !----------------------------------------------------------------------------------
@@ -250,4 +251,11 @@
 /
 !-----------------------------------------------------------------------
+&namzdf_tmx_new !   internal wave-driven mixing parameterization        ("key_zdftmx_new" & "key_zdfddm")
+!-----------------------------------------------------------------------
+   nn_zpyc     = 2         !  pycnocline-intensified dissipation scales as N (=1) or N^2 (=2)
+   ln_mevar    = .true.    !  variable (T) or constant (F) mixing efficiency
+   ln_tsdiff   = .true.    !  account for differential T/S mixing (T) or not (F)
+/
+!-----------------------------------------------------------------------
 &nammpp        !   Massively Parallel Processing                        ("key_mpp_mpi)
 !-----------------------------------------------------------------------
Index: /trunk/NEMOGCM/CONFIG/ORCA2_LIM3_PISCES/cpp_ORCA2_LIM3_PISCES.fcm
===================================================================
--- /trunk/NEMOGCM/CONFIG/ORCA2_LIM3_PISCES/cpp_ORCA2_LIM3_PISCES.fcm	(revision 7827)
+++ /trunk/NEMOGCM/CONFIG/ORCA2_LIM3_PISCES/cpp_ORCA2_LIM3_PISCES.fcm	(revision 7828)
@@ -1,1 +1,1 @@
-bld::tool::fppkeys key_trabbl key_lim3 key_zdftke key_zdfddm key_zdftmx key_iomput key_mpp_mpi key_top key_nosignedzero
+bld::tool::fppkeys key_trabbl key_lim3 key_zdftke key_zdfddm key_zdftmx_new key_iomput key_mpp_mpi key_top key_nosignedzero
Index: /trunk/NEMOGCM/CONFIG/SHARED/field_def_nemo-opa.xml
===================================================================
--- /trunk/NEMOGCM/CONFIG/SHARED/field_def_nemo-opa.xml	(revision 7827)
+++ /trunk/NEMOGCM/CONFIG/SHARED/field_def_nemo-opa.xml	(revision 7828)
@@ -92,5 +92,5 @@
          <field id="hc300"        long_name="Heat content 0-300m"                            standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"                      />
 
-         <!-- variables available with key_diaar5 -->
+         <!-- variables available with diaar5 -->
          <field id="botpres"      long_name="Sea Water Pressure at Sea Floor"   standard_name="sea_water_pressure_at_sea_floor"   unit="dbar" />
          <field id="sshdyn"       long_name="dynamic sea surface height"     standard_name="dynamic_sea_surface_height_above_geoid"     unit="m" />
@@ -98,5 +98,5 @@
          <field id="tnpeo"      long_name="Tendency of ocean potential energy content"          unit="W/m2"                           />
 
-         <!-- variables available with key_vvl -->
+         <!-- variables available ln_linssh=.FALSE. -->
          <field id="tpt_dep"      long_name="T-point depth"                  standard_name="depth_below_geoid"   unit="m"   grid_ref="grid_T_3D" />
          <field id="e3tdef"       long_name="T-cell thickness deformation"                                       unit="%"   grid_ref="grid_T_3D" />
@@ -362,5 +362,5 @@
          <field id="vtbl"         long_name="meridional current in the Losh tbl"   unit="m/s" />
 
-         <!-- variables available with key_diaar5 -->
+         <!-- variables available with diaar5 -->
          <field id="v_masstr"     long_name="ocean eulerian mass transport along j-axis"    standard_name="ocean_mass_y_transport"                          unit="kg/s"        grid_ref="grid_V_3D" />
          <field id="v_heattr"     long_name="ocean eulerian heat transport along j-axis"    standard_name="ocean_heat_y_transport"                          unit="W"                                />
@@ -401,5 +401,12 @@
          <field id="av_tide"      long_name="tidal vertical diffusivity"   standard_name="ocean_vertical_tracer_diffusivity_due_to_tides"   unit="m2/s" />
 
-         <!-- variables available with key_diaar5 -->   
+         <!-- variables available with key_zdftmx_new -->
+         <field id="av_ratio"     long_name="S over T diffusivity ratio"            standard_name="salinity_over_temperature_diffusivity_ratio"                     unit="1"    />
+         <field id="av_wave"      long_name="wave-induced vertical diffusivity"     standard_name="ocean_vertical_tracer_diffusivity_due_to_internal_waves"         unit="m2/s" />
+         <field id="bflx_tmx"     long_name="wave-induced buoyancy flux"            standard_name="buoyancy_flux_due_to_internal_waves"                             unit="W/kg" />
+         <field id="pcmap_tmx"    long_name="power consumed by wave-driven mixing"  standard_name="vertically_integrated_power_consumption_by_wave_driven_mixing"   unit="W/m2"      grid_ref="grid_W_2D" />
+         <field id="emix_tmx"     long_name="power density available for mixing"    standard_name="power_available_for_mixing_from_breaking_internal_waves"         unit="W/kg" />
+
+         <!-- variables available with diaar5 -->   
          <field id="w_masstr"     long_name="vertical mass transport"             standard_name="upward_ocean_mass_transport"             unit="kg/s"   />
          <field id="w_masstr2"    long_name="square of vertical mass transport"   standard_name="square_of_upward_ocean_mass_transport"   unit="kg2/s2" />
@@ -438,6 +445,6 @@
          <field id="bgfrchfx"     long_name="global mean heat flux from forcing"                                                                                                    unit="W/m2"     />
          <field id="bgfrcsal"     long_name="global mean salt content from forcing"                                                                                                 unit="1e-3*km3" />
-         <field id="bgmistem"     long_name="global mean temperature error due to free surface (no vvl)"                                                                            unit="degC"     />
-         <field id="bgmissal"     long_name="global mean salinity error due to free surface (no vvl)"                                                                               unit="1e-3"     />
+         <field id="bgmistem"     long_name="global mean temperature error due to free surface (linssh true)"                                                                            unit="degC"     />
+         <field id="bgmissal"     long_name="global mean salinity error due to free surface (linssh true)"                                                                               unit="1e-3"     />
       </field_group>
   
@@ -564,6 +571,6 @@
        <field id="ttrd_totad"    long_name="temperature-trend: total advection"         standard_name="tendency_of_sea_water_salinity_due_to_advection"              unit="degC/s"                        />
        <field id="strd_totad"    long_name="salinity   -trend: total advection"         standard_name="tendency_of_sea_water_salinity_due_to_advection"              unit="1e-3/s"                        />
-       <field id="ttrd_sad"      long_name="temperature-trend: surface adv. (no-vvl)"                                                                                unit="degC/s"   grid_ref="grid_T_2D" />
-       <field id="strd_sad"      long_name="salinity   -trend: surface adv. (no-vvl)"                                                                                unit="1e-3/s"   grid_ref="grid_T_2D" />
+       <field id="ttrd_sad"      long_name="temperature-trend: surface adv. (linssh true)"                                                                                unit="degC/s"   grid_ref="grid_T_2D" />
+       <field id="strd_sad"      long_name="salinity   -trend: surface adv. (linssh true)"                                                                                unit="1e-3/s"   grid_ref="grid_T_2D" />
        <field id="ttrd_ldf"      long_name="temperature-trend: lateral  diffusion"      standard_name="tendency_of_sea_water_temperature_due_to_horizontal_mixing"   unit="degC/s"                        />
        <field id="strd_ldf"      long_name="salinity   -trend: lateral  diffusion"      standard_name="tendency_of_sea_water_salinity_due_to_horizontal_mixing"      unit="1e-3/s"                        />
@@ -663,5 +670,5 @@
        <field id="petrd_yad"     long_name="pe-trend: j-advection"                unit="W/m^3"                        />
        <field id="petrd_zad"     long_name="pe-trend: k-advection"                unit="W/m^3"                        />
-       <field id="petrd_sad"     long_name="pe-trend: surface adv. (no-vvl)"      unit="W/m^3"   grid_ref="grid_T_2D" />
+       <field id="petrd_sad"     long_name="pe-trend: surface adv. (linssh true)"      unit="W/m^3"   grid_ref="grid_T_2D" />
        <field id="petrd_ldf"     long_name="pe-trend: lateral  diffusion"         unit="W/m^3"                        />
        <field id="petrd_zdf"     long_name="pe-trend: vertical diffusion"         unit="W/m^3"                        />
Index: /trunk/NEMOGCM/CONFIG/SHARED/field_def_nemo-pisces.xml
===================================================================
--- /trunk/NEMOGCM/CONFIG/SHARED/field_def_nemo-pisces.xml	(revision 7827)
+++ /trunk/NEMOGCM/CONFIG/SHARED/field_def_nemo-pisces.xml	(revision 7828)
@@ -216,5 +216,5 @@
        <field id="Ironsed"     long_name="Iron deposition from sediment"           unit="mol/m2/s"   grid_ref="grid_T_3D" />
 
-       <!-- dbio_T on T grid : variables available with key_diaar5 -->
+       <!-- dbio_T on T grid : variables available with diaar5 -->
        <field id="TPP"         long_name="Total Primary production of phyto"                   unit="mol/m3/s"  grid_ref="grid_T_3D" />
        <field id="TPNEW"       long_name="New Primary production of phyto"                     unit="mol/m3/s"  grid_ref="grid_T_3D" />
Index: /trunk/NEMOGCM/TOOLS/DOMAINcfg/README
===================================================================
--- /trunk/NEMOGCM/TOOLS/DOMAINcfg/README	(revision 7827)
+++ /trunk/NEMOGCM/TOOLS/DOMAINcfg/README	(revision 7828)
@@ -15,5 +15,5 @@
 just run :
 :::::::::::::::::::::::::::::::::::::::::::::::::
-./make_domain_cfg.exe
+mpirun -np 1 ./make_domain_cfg.exe
 :::::::::::::::::::::::::::::::::::::::::::::::::
 NOTA: it can be run in multiproc mode, but in output there will be domain_cfg_00xx.nc files