Index: branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/README
===================================================================
--- branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/README	(revision 7844)
+++ branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/README	(revision 7925)
@@ -45,5 +45,5 @@
                INPUT_DIR   	   : directory in which store input files (tar file)
                TMPDIR      	   : temporary directory NEEDED ONLY FOR IBM machines (put EXP00 directory)
-	       NEMO_VALIDATION_DIR : directory in which create NEMO_VALIDATION tree, and store restart, solver.stat, tracer.stat and ocean.output files in
+	       NEMO_VALIDATION_DIR : directory in which create NEMO_VALIDATION tree, and store restart, run.stat, tracer.stat and ocean.output files in
       			             tree NEMO_VALIDATION_DIR/WCONFIG_NAME/WCOMPILER_NAME/TEST_NAME/REVISION_NUMBER(or DATE)
  in fcm_job.sh :
Index: branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/all_functions.sh
===================================================================
--- branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/all_functions.sh	(revision 7844)
+++ branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/all_functions.sh	(revision 7925)
@@ -219,17 +219,17 @@
     fi
     # Save output & debug files in NEMO_VALIDATION tree
-    echo "saving ocean & ice output, solver.stat, tracer.stat files ...." >> ${SETTE_DIR}/output.sette
+    echo "saving ocean & ice output, run.stat, tracer.stat files ...." >> ${SETTE_DIR}/output.sette
     echo "            " >> ${SETTE_DIR}/output.sette
     [ -f ${EXE_DIR}/ocean.output ] && cp ${EXE_DIR}/*ocean.output ${NEMO_VALID}/.
-    [ -f ${EXE_DIR}/solver.stat ] && cp ${EXE_DIR}/*solver.stat ${NEMO_VALID}/.
+    [ -f ${EXE_DIR}/run.stat ] && cp ${EXE_DIR}/*run.stat ${NEMO_VALID}/.
     [ -f ${EXE_DIR}/output.namelist.dyn ] && cp ${EXE_DIR}/*output.nam* ${NEMO_VALID}/.
     [ -f ${EXE_DIR}/tracer.stat ] && cp ${EXE_DIR}/*tracer.stat ${NEMO_VALID}/.
 
-    if [ -n "$(ls ${NEMO_VALID}/*solver*)" ] ; then
-	echo "moved solver.stat in ${NEMO_VALID} directory"  >> ${SETTE_DIR}/output.sette
-	echo "moved solver.stat in ${NEMO_VALID} directory"  
+    if [ -n "$(ls ${NEMO_VALID}/*run*)" ] ; then
+	echo "moved run.stat in ${NEMO_VALID} directory"  >> ${SETTE_DIR}/output.sette
+	echo "moved run.stat in ${NEMO_VALID} directory"  
     else
-	echo "problem in looking for solver.stat file in ${NEMO_VALID} directory"  >> ${SETTE_DIR}/output.sette
-	echo "solver.stat IS NOT in ${NEMO_VALID} directory" 
+	echo "problem in looking for run.stat file in ${NEMO_VALID} directory"  >> ${SETTE_DIR}/output.sette
+	echo "run.stat IS NOT in ${NEMO_VALID} directory" 
     fi
     if [ -n "$(ls ${NEMO_VALID}/*ocean.output*)" ] ; then
Index: branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/sette.sh
===================================================================
--- branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/sette.sh	(revision 7844)
+++ branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/sette.sh	(revision 7925)
@@ -56,5 +56,5 @@
 #   set_namelist     : function declared in all_functions that sets namelist parameters 
 #   post_test_tidyup : creates validation storage directory and copies required output files 
-#                      (solver.stat and ocean.output) in it after execution of test.
+#                      (run.stat and ocean.output) in it after execution of test.
 #
 #  VALIDATION tree is:
@@ -137,5 +137,5 @@
 # ORCA2_OFF_PISCES  :  5 &  6
 # AMM12             :  7 &  8 
-# SAS               :  9     fos SAS there is no solver so is useless to test REPRO
+# SAS               :  9     fos SAS there is no run.stat so is useless to test REPRO
 # ISOMIP            : 10 & 11
 # ORCA2_LIM3_OBS    : 12
@@ -661,5 +661,5 @@
     export TEST_NAME="LONG"
     cd ${CONFIG_DIR0}
-    . ./makenemo -m ${CMP_NAM} -n AMM12_LONG -r AMM12 -j 8 add_key "key_tide" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n AMM12_LONG -r AMM12 -j 8 del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1121,4 +1121,5 @@
     set_namelist 1_namelist_cfg nn_it000 1
     set_namelist 1_namelist_cfg nn_itend 150
+    set_namelist 1_namelist_cfg nn_fsbc 1
     set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg ln_clobber .true.
@@ -1245,4 +1246,5 @@
     set_namelist 1_namelist_cfg nn_itend 300
     set_namelist 1_namelist_cfg nn_stock 150
+    set_namelist 1_namelist_cfg nn_fsbc 1
     set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg ln_clobber .true.
@@ -1283,4 +1285,5 @@
     set_namelist 1_namelist_cfg nn_itend 300
     set_namelist 1_namelist_cfg nn_stock 150
+    set_namelist 1_namelist_cfg nn_fsbc 1
     set_namelist 1_namelist_cfg ln_rstart .true.
     set_namelist 1_namelist_cfg nn_rstctl 2
@@ -1339,4 +1342,5 @@
     set_namelist 1_namelist_cfg nn_it000 1
     set_namelist 1_namelist_cfg nn_itend 150
+    set_namelist 1_namelist_cfg nn_fsbc 1
     set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg ln_clobber .true.
@@ -1378,4 +1382,5 @@
     set_namelist 1_namelist_cfg nn_itend 150
     set_namelist 1_namelist_cfg ln_ctl .false.
+    set_namelist 1_namelist_cfg nn_fsbc 1
     set_namelist 1_namelist_cfg ln_clobber .true.
     set_namelist 1_namelist_cfg ln_read_cfg .true.
Index: branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/sette_beginner.sh
===================================================================
--- branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/sette_beginner.sh	(revision 7844)
+++ branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/sette_beginner.sh	(revision 7925)
@@ -55,5 +55,5 @@
 #   set_namelist     : function declared in all_functions that sets namelist parameters 
 #   post_test_tidyup : creates validation storage directory and copies required output files 
-#                      (solver.stat and ocean.output) in it after execution of test.
+#                      (run.stat and ocean.output) in it after execution of test.
 #
 #  VALIDATION tree is:
Index: branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/sette_xios.sh
===================================================================
--- branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/sette_xios.sh	(revision 7844)
+++ branches/2017/dev_r7832_HPC08_lbclnk_3rd_dim/NEMOGCM/SETTE/sette_xios.sh	(revision 7925)
@@ -52,5 +52,5 @@
 #   set_namelist     : function declared in all_functions that sets namelist parameters 
 #   post_test_tidyup : creates validation storage directory and copies required output files 
-#                      (solver.stat and ocean.output) in it after execution of test.
+#                      (run.stat and ocean.output) in it after execution of test.
 #
 #  VALIDATION tree is: