Index: branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_mod.F90
===================================================================
--- branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_mod.F90	(revision 7927)
+++ branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_mod.F90	(revision 7938)
@@ -19,4 +19,14 @@
    PUBLIC   bio_medusa_alloc     ! called by trcini.F90
 
+   !! model state variables
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::    zchn,zchd,zphn,zphd,zpds,zzmi
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::    zzme,zdet,zdtc,zdin,zsil,zfer
+# if defined key_roam
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::    zdic, zalk, zoxy
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::    ztmp, zsal
+# endif
+# if defined key_mocsy
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::    zpho
+# endif
 
    !! AXY (01/03/10): add in mixed layer PP diagnostics
@@ -62,5 +72,19 @@
    REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: fsil_prod,fsil_cons
 
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: f_xco2a
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: f_ph,f_pco2w,f_h2co3
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: f_hco3,f_co3,f_co2flux
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: f_TDIC,f_TALK,f_dcf,f_henry
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: f_pp0
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: f_kw660,f_o2flux,f_o2sat
    REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: f_omcal,f_omarg
+
+   !! AXY (23/06/15): additional diagnostics for MOCSY and oxygen
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: f_fco2w,f_BetaD,f_rhosw,f_opres
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: f_insitut,f_pco2atm,f_fco2atm
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: f_schmidtco2,f_kwco2,f_K0
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: f_co2starair,f_dpco2,f_kwo2
+
+   INTEGER, ALLOCATABLE, DIMENSION(:,:)  :: iters 
 
    !! Carbon, alkalinity production and consumption
@@ -172,5 +196,12 @@
       !!-------------------------------------------------------------------
       !
-      ALLOCATE(fprn_ml(jpi,jpj),fprd_ml(jpi,jpj),                     &
+      ALLOCATE(zchn(jpi,jpj),zchd(jpi,jpj),zphn(jpi,jpj),             &
+               zphd(jpi,jpj),zpds(jpi,jpj),zzmi(jpi,jpj),             &
+               zzme(jpi,jpj),zdet(jpi,jpj),zdtc(jpi,jpj),             &
+               zdin(jpi,jpj),zsil(jpi,jpj),zfer(jpi,jpj),             &
+               zdic(jpi,jpj),zalk(jpi,jpj),zoxy(jpi,jpj),             &
+               ztmp(jpi,jpj),zsal(jpi,jpj),                           &
+               zpho(jpi,jpj),                                         &
+               fprn_ml(jpi,jpj),fprd_ml(jpi,jpj),                     &
                xFree(jpi,jpj),                                        &
                fslownflux(jpi,jpj),fslowcflux(jpi,jpj),               &
@@ -201,5 +232,19 @@
                fnit_prod(jpi,jpj),fnit_cons(jpi,jpj),                 &
                fsil_prod(jpi,jpj),fsil_cons(jpi,jpj),                 &
+               f_xco2a(jpi,jpj),                                      &
+               f_ph(jpi,jpj),f_pco2w(jpi,jpj),f_h2co3(jpi,jpj),       &
+               f_hco3(jpi,jpj),f_co3(jpi,jpj),f_co2flux(jpi,jpj),     &
+               f_TDIC(jpi,jpj),f_TALK(jpi,jpj),f_dcf(jpi,jpj),        &
+               f_henry(jpi,jpj),                                      &
+               f_pp0(jpi,jpj),                                        &
+               f_kw660(jpi,jpj),f_o2flux(jpi,jpj),f_o2sat(jpi,jpj),   &
                f_omcal(jpi,jpj),f_omarg(jpi,jpj),                     &
+               f_fco2w(jpi,jpj),f_BetaD(jpi,jpj),f_rhosw(jpi,jpj),    &
+               f_opres(jpi,jpj),f_insitut(jpi,jpj),                   &
+               f_pco2atm(jpi,jpj),f_fco2atm(jpi,jpj),                 &
+               f_schmidtco2(jpi,jpj),f_kwco2(jpi,jpj),f_K0(jpi,jpj),  &
+               f_co2starair(jpi,jpj),f_dpco2(jpi,jpj),                &
+               f_kwo2(jpi,jpj),                                       &
+               iters(jpi,jpj),                                        &
                fcomm_resp(jpi,jpj),                                   &
                fcar_prod(jpi,jpj),fcar_cons(jpi,jpj),                 &